package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.result.CustomException;
import com.ims.eval.entity.EvaluateRule;
import com.ims.eval.entity.EvaluateRuleInfo;
import com.ims.eval.dao.EvaluateRuleInfoMapper;
import com.ims.eval.service.IEvaluateRuleInfoService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.SneakyThrows;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * <p>
 * 考评规则信息 服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-02-28
 */
@Service
public class EvaluateRuleInfoServiceImpl extends ServiceImpl<EvaluateRuleInfoMapper, EvaluateRuleInfo> implements IEvaluateRuleInfoService {

	@Override
	public List<EvaluateRuleInfo> list(String id, String des, String indicatorId,String evaluateRuleId) {

		QueryWrapper<EvaluateRuleInfo> qw = new QueryWrapper<>();


		if (StringUtils.isNotEmpty(id)) {
			qw.lambda().eq(EvaluateRuleInfo::getId, id);
		}

		if (StringUtils.isNotEmpty(des)) {
			qw.lambda().like(EvaluateRuleInfo::getDes, des);
		}

		if (StringUtils.isNotEmpty(indicatorId)) {
			qw.lambda().eq(EvaluateRuleInfo::getIndicatorId, indicatorId);
		}
		if (StringUtils.isNotEmpty(evaluateRuleId)) {
			qw.lambda().eq(EvaluateRuleInfo::getEvaluateRuleId, evaluateRuleId);
		}

		qw.lambda().orderByAsc(EvaluateRuleInfo::getOrderNum);

		List<EvaluateRuleInfo> list = baseMapper.selectList( qw);

		return list;
	}


	@Override
	public boolean saveOrUpdate(EvaluateRuleInfo entity) {

		if (null != entity && (null == entity.getId() || "".equals(entity.getId().trim()))) {
			QueryWrapper<EvaluateRuleInfo> qw = new QueryWrapper<>();
			qw.lambda().eq(EvaluateRuleInfo::getEvaluateRuleId, entity.getEvaluateRuleId());
			qw.lambda().eq(EvaluateRuleInfo::getIndicatorId, entity.getIndicatorId());
			List<EvaluateRuleInfo> list = baseMapper.selectList(qw);
			if (null != list && list.size() > 0) {
				throw new CustomException("该指标已存在");
			}
			entity.setCreateTime(new Date());
		} else {
			entity.setUpdateTime(new Date());
		}

		return super.saveOrUpdate(entity);
	}
}
