/**
 *
 */
package com.ims.eval.controller;

import com.ims.core.controller.WebController;
import com.ims.core.utils.StringUtils;

import com.ims.eval.entity.EvaluateScore;
import com.ims.eval.service.IEvaluateScoreService;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * 考评得分Controller
 * @author wang
 * @version 2023-02-23
 */
@Controller
@RequestMapping(value = "/eval/evaluateScore")
public class EvaluateScoreController extends WebController<IEvaluateScoreService, EvaluateScore> {

 	//@ImsPreAuth("eval:evaluateScore:view")
	@RequestMapping(value = "list")
	public String list(EvaluateScore evaluateScore, Model model) {
		return "ims/ims-eval${ims_eval_suffix}/eval/evaluateScoreList";
	}

    //@ImsPreAuth("eval:evaluateScore:view")
	@RequestMapping(value = "form")
	public String form(EvaluateScore evaluateScore, Model model) {
	    String formView = evaluateScore.getFormView();
	    if(StringUtils.isNotBlank(formView)){
			return "ims/"+formView;
		}
		return "ims/ims-eval${ims_eval_suffix}/eval/evaluateScoreForm";
	}

    //@ImsPreAuth("eval:evaluateScore:view")
	@RequestMapping(value = "lov")
	public String lov(EvaluateScore evaluateScore, Model model) {
		return "ims/ims-eval${ims_eval_suffix}/eval/evaluateScoreList";
	}

    //@ImsPreAuth("eval:evaluateScore:view")
	@RequestMapping(value = "data")
	@ResponseBody
	public String getData(EvaluateScore evaluateScore, HttpServletRequest request, HttpServletResponse response, Model model)  throws IOException  {
        return  super.getData(evaluateScore,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateScore:view")
	@RequestMapping(value = "allData")
	@ResponseBody
	public String getAllData(EvaluateScore evaluateScore, HttpServletRequest request, HttpServletResponse response, Model model)  throws IOException  {
        return  super.getAllData(evaluateScore,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateScore:view")
	@RequestMapping(value = "get")
	@ResponseBody
	public String get(EvaluateScore evaluateScore, HttpServletRequest request, HttpServletResponse response, Model model) throws IOException {
        return  super.get(evaluateScore,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateScore:edit")
	@RequestMapping(value = "initInsert")
	@ResponseBody
	public String initInsert(EvaluateScore evaluateScore, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.initInsert(evaluateScore,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateScore:edit")
	@RequestMapping(value = "checkSave")
	@ResponseBody
	public String checkSave(EvaluateScore evaluateScore, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.checkSave(evaluateScore,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateScore:edit")
	@RequestMapping(value = "save")
	@ResponseBody
	public String save(EvaluateScore evaluateScore, Model model,  HttpServletRequest request, HttpServletResponse response) {
		 return super.save(evaluateScore,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateScore:remove")
	@RequestMapping(value = "checkRemove")
	@ResponseBody
	public String checkRemove(EvaluateScore evaluateScore, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.checkRemove(evaluateScore,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateScore:remove")
	@RequestMapping(value = "remove")
	@ResponseBody
	public String remove(EvaluateScore evaluateScore, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.remove(evaluateScore,request,response,model);
	}

    //@ImsPreAuth("eval:evaluateScore:edit")
	@RequestMapping(value = "import",produces=MediaType.APPLICATION_JSON_UTF8_VALUE)
	@ResponseBody
	public String importFile(EvaluateScore evaluateScore,MultipartFile excelFile, HttpServletRequest request, HttpServletResponse response) {
         return super.importFile(evaluateScore,excelFile,null,request,response);
	}

    //@ImsPreAuth("eval:evaluateScore:view")
	@RequestMapping(value = "export", method= RequestMethod.POST)
	public void exportFile(EvaluateScore evaluateScore, HttpServletRequest request, HttpServletResponse response) {
         super.exportFile(evaluateScore,request,response );
	}

}
