/**
 *
 */
package com.ims.eval.controller;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.ims.system.auth.ImsPreAuth;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;

import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.http.MediaType;


import org.springframework.web.bind.annotation.*;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;

import com.ims.core.controller.WebController;
import com.ims.core.utils.StringUtils;

import com.ims.eval.entity.Report;
import com.ims.eval.service.IReportService;

/**
 * 发布公告表Controller
 * @author wang
 * @version 2023-02-25
 */
@Controller
@RequestMapping(value = "/eval/report")
public class ReportController extends WebController<IReportService,Report> {

 	//@ImsPreAuth("eval:report:view")
	@RequestMapping(value = "list")
	public String list(Report report, Model model) {
		return "ims/ims-eval${ims_eval_suffix}/eval/reportList";
	}

    //@ImsPreAuth("eval:report:view")
	@RequestMapping(value = "form")
	public String form(Report report, Model model) {
	    String formView = report.getFormView();
	    if(StringUtils.isNotBlank(formView)){
			return "ims/"+formView;
		}
		return "ims/ims-eval${ims_eval_suffix}/eval/reportForm";
	}

    //@ImsPreAuth("eval:report:view")
	@RequestMapping(value = "lov")
	public String lov(Report report, Model model) {
		return "ims/ims-eval${ims_eval_suffix}/eval/reportList";
	}

    //@ImsPreAuth("eval:report:view")
	@RequestMapping(value = "data")
	@ResponseBody
	public String getData(Report report, HttpServletRequest request, HttpServletResponse response, Model model)  throws IOException  {
        return  super.getData(report,request,response,model);
	}

    //@ImsPreAuth("eval:report:view")
	@RequestMapping(value = "allData")
	@ResponseBody
	public String getAllData(Report report, HttpServletRequest request, HttpServletResponse response, Model model)  throws IOException  {
        return  super.getAllData(report,request,response,model);
	}

    //@ImsPreAuth("eval:report:view")
	@RequestMapping(value = "get")
	@ResponseBody
	public String get(Report report, HttpServletRequest request, HttpServletResponse response, Model model) throws IOException {
        return  super.get(report,request,response,model);
	}

    //@ImsPreAuth("eval:report:edit")
	@RequestMapping(value = "initInsert")
	@ResponseBody
	public String initInsert(Report report, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.initInsert(report,request,response,model);
	}

    //@ImsPreAuth("eval:report:edit")
	@RequestMapping(value = "checkSave")
	@ResponseBody
	public String checkSave(Report report, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.checkSave(report,request,response,model);
	}

    //@ImsPreAuth("eval:report:edit")
	@RequestMapping(value = "save")
	@ResponseBody
	public String save(Report report, Model model,  HttpServletRequest request, HttpServletResponse response) {
		 return super.save(report,request,response,model);
	}

    //@ImsPreAuth("eval:report:remove")
	@RequestMapping(value = "checkRemove")
	@ResponseBody
	public String checkRemove(Report report, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.checkRemove(report,request,response,model);
	}

    //@ImsPreAuth("eval:report:remove")
	@RequestMapping(value = "remove")
	@ResponseBody
	public String remove(Report report, Model model, HttpServletRequest request, HttpServletResponse response) throws Exception {
		return super.remove(report,request,response,model);
	}

    //@ImsPreAuth("eval:report:edit")
	@RequestMapping(value = "import",produces=MediaType.APPLICATION_JSON_UTF8_VALUE)
	@ResponseBody
	public String importFile(Report report,MultipartFile excelFile, HttpServletRequest request, HttpServletResponse response) {
         return super.importFile(report,excelFile,null,request,response);
	}

    //@ImsPreAuth("eval:report:view")
	@RequestMapping(value = "export", method= RequestMethod.POST)
	public void exportFile(Report report, HttpServletRequest request, HttpServletResponse response) {
         super.exportFile(report,request,response );
	}

}